package com.toughra.ustadmobile.databinding;
import com.toughra.ustadmobile.R;
import com.toughra.ustadmobile.BR;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.view.View;
@SuppressWarnings("unchecked")
public class ItemReportEditSeriesBindingImpl extends ItemReportEditSeriesBinding implements com.toughra.ustadmobile.generated.callback.OnClickListener.Listener {

    @Nullable
    private static final androidx.databinding.ViewDataBinding.IncludedLayouts sIncludes;
    @Nullable
    private static final android.util.SparseIntArray sViewsWithIds;
    static {
        sIncludes = new androidx.databinding.ViewDataBinding.IncludedLayouts(13);
        sIncludes.setIncludes(0, 
            new String[] {"item_createnew"},
            new int[] {6},
            new int[] {com.toughra.ustadmobile.R.layout.item_createnew});
        sViewsWithIds = new android.util.SparseIntArray();
        sViewsWithIds.put(R.id.item_report_series_title_text_inputlayout, 7);
        sViewsWithIds.put(R.id.item_edit_report_dialog_yaxis_textinputlayout, 8);
        sViewsWithIds.put(R.id.item_edit_report_dialog_visual_type_textinputlayout, 9);
        sViewsWithIds.put(R.id.item_edit_report_dialog_subgroup_textinputlayout, 10);
        sViewsWithIds.put(R.id.item_report_edit_header_filter, 11);
        sViewsWithIds.put(R.id.item_report_edit_filter_list, 12);
    }
    // views
    // variables
    @Nullable
    private final android.view.View.OnClickListener mCallback47;
    @Nullable
    private final android.view.View.OnClickListener mCallback46;
    // values
    // listeners
    // Inverse Binding Event Handlers
    private androidx.databinding.InverseBindingListener itemEditReportDialogSubgroupTextselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of series.reportSeriesSubGroup
            //         is series.setReportSeriesSubGroup((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(itemEditReportDialogSubgroupText);
            // localize variables for thread safety
            // series != null
            boolean seriesJavaLangObjectNull = false;
            // series
            com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;
            // series.reportSeriesSubGroup
            int seriesReportSeriesSubGroup = 0;



            seriesJavaLangObjectNull = (series) != (null);
            if (seriesJavaLangObjectNull) {




                series.setReportSeriesSubGroup(((int) (callbackArg_0)));
            }
        }
    };
    private androidx.databinding.InverseBindingListener itemEditReportDialogVisualTypeTextselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of series.reportSeriesVisualType
            //         is series.setReportSeriesVisualType((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(itemEditReportDialogVisualTypeText);
            // localize variables for thread safety
            // series != null
            boolean seriesJavaLangObjectNull = false;
            // series
            com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;
            // series.reportSeriesVisualType
            int seriesReportSeriesVisualType = 0;



            seriesJavaLangObjectNull = (series) != (null);
            if (seriesJavaLangObjectNull) {




                series.setReportSeriesVisualType(((int) (callbackArg_0)));
            }
        }
    };
    private androidx.databinding.InverseBindingListener itemEditReportDialogYaxisTextselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of series.reportSeriesYAxis
            //         is series.setReportSeriesYAxis((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(itemEditReportDialogYaxisText);
            // localize variables for thread safety
            // series != null
            boolean seriesJavaLangObjectNull = false;
            // series
            com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;
            // series.reportSeriesYAxis
            int seriesReportSeriesYAxis = 0;



            seriesJavaLangObjectNull = (series) != (null);
            if (seriesJavaLangObjectNull) {




                series.setReportSeriesYAxis(((int) (callbackArg_0)));
            }
        }
    };
    private androidx.databinding.InverseBindingListener itemReportSeriesTitleTextandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of series.reportSeriesName
            //         is series.setReportSeriesName((java.lang.String) callbackArg_0)
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(itemReportSeriesTitleText);
            // localize variables for thread safety
            // series != null
            boolean seriesJavaLangObjectNull = false;
            // series.reportSeriesName
            java.lang.String seriesReportSeriesName = null;
            // series
            com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;



            seriesJavaLangObjectNull = (series) != (null);
            if (seriesJavaLangObjectNull) {




                series.setReportSeriesName(((java.lang.String) (callbackArg_0)));
            }
        }
    };

    public ItemReportEditSeriesBindingImpl(@Nullable androidx.databinding.DataBindingComponent bindingComponent, @NonNull View root) {
        this(bindingComponent, root, mapBindings(bindingComponent, root, 13, sIncludes, sViewsWithIds));
    }
    private ItemReportEditSeriesBindingImpl(androidx.databinding.DataBindingComponent bindingComponent, View root, Object[] bindings) {
        super(bindingComponent, root, 1
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[5]
            , (com.google.android.material.textfield.TextInputLayout) bindings[10]
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[4]
            , (com.google.android.material.textfield.TextInputLayout) bindings[9]
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[3]
            , (com.google.android.material.textfield.TextInputLayout) bindings[8]
            , (com.toughra.ustadmobile.databinding.ItemCreatenewBinding) bindings[6]
            , (androidx.recyclerview.widget.RecyclerView) bindings[12]
            , (android.widget.TextView) bindings[11]
            , (android.widget.ImageView) bindings[2]
            , (com.google.android.material.textfield.TextInputEditText) bindings[1]
            , (com.google.android.material.textfield.TextInputLayout) bindings[7]
            , (androidx.constraintlayout.widget.ConstraintLayout) bindings[0]
            );
        this.itemEditReportDialogSubgroupText.setTag(null);
        this.itemEditReportDialogVisualTypeText.setTag(null);
        this.itemEditReportDialogYaxisText.setTag(null);
        setContainedBinding(this.itemEditReportFilterAddLayout);
        this.itemReportSeriesDeleteButton.setTag(null);
        this.itemReportSeriesTitleText.setTag(null);
        this.seriesLayout.setTag(null);
        setRootTag(root);
        // listeners
        mCallback47 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 2);
        mCallback46 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 1);
        invalidateAll();
    }

    @Override
    public void invalidateAll() {
        synchronized(this) {
                mDirtyFlags = 0x800L;
        }
        itemEditReportFilterAddLayout.invalidateAll();
        requestRebind();
    }

    @Override
    public boolean hasPendingBindings() {
        synchronized(this) {
            if (mDirtyFlags != 0) {
                return true;
            }
        }
        if (itemEditReportFilterAddLayout.hasPendingBindings()) {
            return true;
        }
        return false;
    }

    @Override
    public boolean setVariable(int variableId, @Nullable Object variable)  {
        boolean variableSet = true;
        if (BR.series == variableId) {
            setSeries((com.ustadmobile.lib.db.entities.ReportSeries) variable);
        }
        else if (BR.visualTypeSelectionListener == variableId) {
            setVisualTypeSelectionListener((com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.eventHandler == variableId) {
            setEventHandler((com.ustadmobile.port.android.view.ReportEditFragmentEventHandler) variable);
        }
        else if (BR.showDeleteButton == variableId) {
            setShowDeleteButton((java.lang.Boolean) variable);
        }
        else if (BR.mPresenter == variableId) {
            setMPresenter((com.ustadmobile.core.controller.ReportEditPresenter) variable);
        }
        else if (BR.subgroupOptions == variableId) {
            setSubgroupOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.yAxisOptions == variableId) {
            setYAxisOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.visualTypeOptions == variableId) {
            setVisualTypeOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.subgroupSelectionListener == variableId) {
            setSubgroupSelectionListener((com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.dataSetSelectionListener == variableId) {
            setDataSetSelectionListener((com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption>) variable);
        }
        else {
            variableSet = false;
        }
            return variableSet;
    }

    public void setSeries(@Nullable com.ustadmobile.lib.db.entities.ReportSeries Series) {
        this.mSeries = Series;
        synchronized(this) {
            mDirtyFlags |= 0x2L;
        }
        notifyPropertyChanged(BR.series);
        super.requestRebind();
    }
    public void setVisualTypeSelectionListener(@Nullable com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> VisualTypeSelectionListener) {
        this.mVisualTypeSelectionListener = VisualTypeSelectionListener;
        synchronized(this) {
            mDirtyFlags |= 0x4L;
        }
        notifyPropertyChanged(BR.visualTypeSelectionListener);
        super.requestRebind();
    }
    public void setEventHandler(@Nullable com.ustadmobile.port.android.view.ReportEditFragmentEventHandler EventHandler) {
        this.mEventHandler = EventHandler;
        synchronized(this) {
            mDirtyFlags |= 0x8L;
        }
        notifyPropertyChanged(BR.eventHandler);
        super.requestRebind();
    }
    public void setShowDeleteButton(@Nullable java.lang.Boolean ShowDeleteButton) {
        this.mShowDeleteButton = ShowDeleteButton;
        synchronized(this) {
            mDirtyFlags |= 0x10L;
        }
        notifyPropertyChanged(BR.showDeleteButton);
        super.requestRebind();
    }
    public void setMPresenter(@Nullable com.ustadmobile.core.controller.ReportEditPresenter MPresenter) {
        this.mMPresenter = MPresenter;
    }
    public void setSubgroupOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> SubgroupOptions) {
        this.mSubgroupOptions = SubgroupOptions;
        synchronized(this) {
            mDirtyFlags |= 0x40L;
        }
        notifyPropertyChanged(BR.subgroupOptions);
        super.requestRebind();
    }
    public void setYAxisOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> YAxisOptions) {
        this.mYAxisOptions = YAxisOptions;
        synchronized(this) {
            mDirtyFlags |= 0x80L;
        }
        notifyPropertyChanged(BR.yAxisOptions);
        super.requestRebind();
    }
    public void setVisualTypeOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> VisualTypeOptions) {
        this.mVisualTypeOptions = VisualTypeOptions;
        synchronized(this) {
            mDirtyFlags |= 0x100L;
        }
        notifyPropertyChanged(BR.visualTypeOptions);
        super.requestRebind();
    }
    public void setSubgroupSelectionListener(@Nullable com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> SubgroupSelectionListener) {
        this.mSubgroupSelectionListener = SubgroupSelectionListener;
        synchronized(this) {
            mDirtyFlags |= 0x200L;
        }
        notifyPropertyChanged(BR.subgroupSelectionListener);
        super.requestRebind();
    }
    public void setDataSetSelectionListener(@Nullable com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> DataSetSelectionListener) {
        this.mDataSetSelectionListener = DataSetSelectionListener;
        synchronized(this) {
            mDirtyFlags |= 0x400L;
        }
        notifyPropertyChanged(BR.dataSetSelectionListener);
        super.requestRebind();
    }

    @Override
    public void setLifecycleOwner(@Nullable androidx.lifecycle.LifecycleOwner lifecycleOwner) {
        super.setLifecycleOwner(lifecycleOwner);
        itemEditReportFilterAddLayout.setLifecycleOwner(lifecycleOwner);
    }

    @Override
    protected boolean onFieldChange(int localFieldId, Object object, int fieldId) {
        switch (localFieldId) {
            case 0 :
                return onChangeItemEditReportFilterAddLayout((com.toughra.ustadmobile.databinding.ItemCreatenewBinding) object, fieldId);
        }
        return false;
    }
    private boolean onChangeItemEditReportFilterAddLayout(com.toughra.ustadmobile.databinding.ItemCreatenewBinding ItemEditReportFilterAddLayout, int fieldId) {
        if (fieldId == BR._all) {
            synchronized(this) {
                    mDirtyFlags |= 0x1L;
            }
            return true;
        }
        return false;
    }

    @Override
    protected void executeBindings() {
        long dirtyFlags = 0;
        synchronized(this) {
            dirtyFlags = mDirtyFlags;
            mDirtyFlags = 0;
        }
        com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;
        com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> visualTypeSelectionListener = mVisualTypeSelectionListener;
        com.ustadmobile.port.android.view.ReportEditFragmentEventHandler eventHandler = mEventHandler;
        java.lang.Boolean showDeleteButton = mShowDeleteButton;
        int showDeleteButtonViewVISIBLEViewGONE = 0;
        int seriesReportSeriesVisualType = 0;
        java.util.List<com.ustadmobile.core.util.IdOption> subgroupOptions = mSubgroupOptions;
        java.util.List<com.ustadmobile.core.util.IdOption> yAxisOptions = mYAxisOptions;
        java.lang.String seriesReportSeriesName = null;
        java.util.List<com.ustadmobile.core.util.IdOption> visualTypeOptions = mVisualTypeOptions;
        boolean androidxDatabindingViewDataBindingSafeUnboxShowDeleteButton = false;
        com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> subgroupSelectionListener = mSubgroupSelectionListener;
        int seriesReportSeriesYAxis = 0;
        int seriesReportSeriesSubGroup = 0;
        com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> dataSetSelectionListener = mDataSetSelectionListener;

        if ((dirtyFlags & 0x9c2L) != 0) {


            if ((dirtyFlags & 0x902L) != 0) {

                    if (series != null) {
                        // read series.reportSeriesVisualType
                        seriesReportSeriesVisualType = series.getReportSeriesVisualType();
                    }
            }
            if ((dirtyFlags & 0x802L) != 0) {

                    if (series != null) {
                        // read series.reportSeriesName
                        seriesReportSeriesName = series.getReportSeriesName();
                    }
            }
            if ((dirtyFlags & 0x882L) != 0) {

                    if (series != null) {
                        // read series.reportSeriesYAxis
                        seriesReportSeriesYAxis = series.getReportSeriesYAxis();
                    }
            }
            if ((dirtyFlags & 0x842L) != 0) {

                    if (series != null) {
                        // read series.reportSeriesSubGroup
                        seriesReportSeriesSubGroup = series.getReportSeriesSubGroup();
                    }
            }
        }
        if ((dirtyFlags & 0x804L) != 0) {
        }
        if ((dirtyFlags & 0x810L) != 0) {



                // read androidx.databinding.ViewDataBinding.safeUnbox(showDeleteButton)
                androidxDatabindingViewDataBindingSafeUnboxShowDeleteButton = androidx.databinding.ViewDataBinding.safeUnbox(showDeleteButton);
            if((dirtyFlags & 0x810L) != 0) {
                if(androidxDatabindingViewDataBindingSafeUnboxShowDeleteButton) {
                        dirtyFlags |= 0x2000L;
                }
                else {
                        dirtyFlags |= 0x1000L;
                }
            }


                // read androidx.databinding.ViewDataBinding.safeUnbox(showDeleteButton) ? View.VISIBLE : View.GONE
                showDeleteButtonViewVISIBLEViewGONE = ((androidxDatabindingViewDataBindingSafeUnboxShowDeleteButton) ? (android.view.View.VISIBLE) : (android.view.View.GONE));
        }
        if ((dirtyFlags & 0x842L) != 0) {
        }
        if ((dirtyFlags & 0x882L) != 0) {
        }
        if ((dirtyFlags & 0x902L) != 0) {
        }
        if ((dirtyFlags & 0xa00L) != 0) {
        }
        if ((dirtyFlags & 0xc00L) != 0) {
        }
        // batch finished
        if ((dirtyFlags & 0xa00L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setOnMessageIdOptionSelected(this.itemEditReportDialogSubgroupText, subgroupSelectionListener);
        }
        if ((dirtyFlags & 0x800L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.itemEditReportDialogSubgroupText, itemEditReportDialogSubgroupTextselectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.itemEditReportDialogVisualTypeText, itemEditReportDialogVisualTypeTextselectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.itemEditReportDialogYaxisText, itemEditReportDialogYaxisTextselectedMessageIdOptionAttrChanged);
            this.itemEditReportFilterAddLayout.setCreateNewText(getRoot().getResources().getString(R.string.filter));
            this.itemEditReportFilterAddLayout.setOnClickNew(mCallback47);
            this.itemReportSeriesDeleteButton.setOnClickListener(mCallback46);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.itemReportSeriesTitleText, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, itemReportSeriesTitleTextandroidTextAttrChanged);
        }
        if ((dirtyFlags & 0x842L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.itemEditReportDialogSubgroupText, subgroupOptions, seriesReportSeriesSubGroup);
        }
        if ((dirtyFlags & 0x804L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setOnMessageIdOptionSelected(this.itemEditReportDialogVisualTypeText, visualTypeSelectionListener);
        }
        if ((dirtyFlags & 0x902L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.itemEditReportDialogVisualTypeText, visualTypeOptions, seriesReportSeriesVisualType);
        }
        if ((dirtyFlags & 0xc00L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setOnMessageIdOptionSelected(this.itemEditReportDialogYaxisText, dataSetSelectionListener);
        }
        if ((dirtyFlags & 0x882L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.itemEditReportDialogYaxisText, yAxisOptions, seriesReportSeriesYAxis);
        }
        if ((dirtyFlags & 0x810L) != 0) {
            // api target 1

            this.itemReportSeriesDeleteButton.setVisibility(showDeleteButtonViewVISIBLEViewGONE);
        }
        if ((dirtyFlags & 0x802L) != 0) {
            // api target 1

            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.itemReportSeriesTitleText, seriesReportSeriesName);
        }
        executeBindingsOn(itemEditReportFilterAddLayout);
    }
    // Listener Stub Implementations
    // callback impls
    public final void _internalCallbackOnClick(int sourceId , android.view.View callbackArg_0) {
        switch(sourceId) {
            case 2: {
                // localize variables for thread safety
                // series
                com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;
                // eventHandler
                com.ustadmobile.port.android.view.ReportEditFragmentEventHandler eventHandler = mEventHandler;
                // eventHandler != null
                boolean eventHandlerJavaLangObjectNull = false;



                eventHandlerJavaLangObjectNull = (eventHandler) != (null);
                if (eventHandlerJavaLangObjectNull) {



                    eventHandler.onClickNewFilter(series);
                }
                break;
            }
            case 1: {
                // localize variables for thread safety
                // series
                com.ustadmobile.lib.db.entities.ReportSeries series = mSeries;
                // eventHandler
                com.ustadmobile.port.android.view.ReportEditFragmentEventHandler eventHandler = mEventHandler;
                // eventHandler != null
                boolean eventHandlerJavaLangObjectNull = false;



                eventHandlerJavaLangObjectNull = (eventHandler) != (null);
                if (eventHandlerJavaLangObjectNull) {



                    eventHandler.onClickRemoveSeries(series);
                }
                break;
            }
        }
    }
    // dirty flag
    private  long mDirtyFlags = 0xffffffffffffffffL;
    /* flag mapping
        flag 0 (0x1L): itemEditReportFilterAddLayout
        flag 1 (0x2L): series
        flag 2 (0x3L): visualTypeSelectionListener
        flag 3 (0x4L): eventHandler
        flag 4 (0x5L): showDeleteButton
        flag 5 (0x6L): mPresenter
        flag 6 (0x7L): subgroupOptions
        flag 7 (0x8L): yAxisOptions
        flag 8 (0x9L): visualTypeOptions
        flag 9 (0xaL): subgroupSelectionListener
        flag 10 (0xbL): dataSetSelectionListener
        flag 11 (0xcL): null
        flag 12 (0xdL): androidx.databinding.ViewDataBinding.safeUnbox(showDeleteButton) ? View.VISIBLE : View.GONE
        flag 13 (0xeL): androidx.databinding.ViewDataBinding.safeUnbox(showDeleteButton) ? View.VISIBLE : View.GONE
    flag mapping end*/
    //end
}